#!/usr/bin/env runghc

{-# OPTIONS_GHC -package fastcgi #-}

-- | Prints the values of all CGI variables and inputs.
module Main where

import Control.Monad (liftM)
import Data.Maybe (fromJust)

import Control.Concurrent
import System.Posix.Process (getProcessID)

import Network.FastCGI

printinput :: CGI CGIResult
printinput = 
    do
--    io (threadDelay 4000000)
    setHeader "Content-type" "text/plain"
    vs <- getVars
    is <- getInputNames
    i <- mapM prInput is
    pid <- liftIO getProcessID
    threadId <- liftIO myThreadId
    let tid = concat $ drop 1 $ words $ show threadId
    output ("Environment:\n" ++ prVars vs
	    ++ "\nInputs:\n" ++ unlines i
	    ++ "\nProcess ID: " ++ show pid
	    ++ "\nThread ID:  " ++ tid)

prVars vs = unlines [k ++ ": " ++ x | (k,x) <- vs ]

prInput :: String -> CGI String
prInput i = 
    do
    v <- liftM fromJust (getInput i)
    f <- getInputFilename i
    return $ case f of
           Just n -> i ++ ": File\nfilename=" ++ n
                     ++ "\ncontents=" ++ v
           Nothing -> i ++ ": " ++ v 

--main = runFastCGIConcurrent printinput
main = runFastCGI printinput
